import java.util.Scanner;

public class ShoppingAnswer {

	public static void main(String[] args) {
		
		Scanner scan = new Scanner(System.in);
		int listSize = 25;
		String[] items = new String[listSize];
		int[] quantity = new int[listSize];
		
		for (int i = 0; i < items.length; i++) {
			items[i] = "";
			quantity[i] = 0;
		}
		
		String input;
		
		do {
			
			System.out.print("Enter an item: ");
			input = scan.nextLine();
			input = input.toUpperCase();
			
			if (input.charAt(0) == '-') {
				removeItem(items, quantity, input.substring(1));
			} else if (!input.equals("DONE")) {
				if (!isFull(items) || containsItem(items, input)) {
					addItem(items, quantity, input);
				} else {
					System.out.println("Error: List is full!");
				}
			}
			
		} while(!input.equals("DONE"));

		System.out.println();
		printList(items, quantity);
	}
	
	private static int countItems(String[] items) {
		
		int count = 0;;
		
		for (int i = 0; i < items.length; i++) {
			if (!items[i].equals("")) {
				count++;
			}
		}
		
		return count;
	}
	
	private static boolean isFull(String[] items) {
		
		boolean isFull;
		
		if (countItems(items) == 25) {
			isFull = true;
		} else {
			isFull = false;
		}
		
		return isFull;
	}
	
	private static boolean containsItem(String[] items, String item) {

		boolean containsItem = false;
		
		for (int i = 0; i < items.length && !containsItem; i++) {
			if (items[i].equals(item)) {
				containsItem = true;
			}
		}
		
		return containsItem;
	}
	
	private static void addItem(String[] items, int[] quantity, String item) {
		
		boolean itemAdded = false;
		
		for (int i = 0; i < items.length && !itemAdded; i++) {
			if (items[i].equals(item) || items[i].equals("")) {
				items[i] = item;
				quantity[i]++;
				itemAdded = true;
			}
		}
	}
	
	private static void removeItem(String[] items, int[] quantity, String item) {
		
		for (int i = 0; i < items.length; i++) {
			if (items[i].equals(item)) {
				quantity[i]--;
				if(quantity[i] == 0) {
					items[i] = "";
				}
			}
		}
	}
	
	private static void printList(String[] items, int[] quantity) {
		
		System.out.println("## There are " + countItems(items) + " items in the list.");
		
		for (int i = 0; i < items.length; i++) {
			if (quantity[i] != 0) {
				System.out.println("## " + quantity[i] + " x " + items[i]);
			}
		}
	}

}
